/* bus.h
 *
 * Copyright (C) 2017 Timothy Richard Musson
 *
 * Email: Tim Musson <trmusson@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */


#ifndef HAVE_BUS_H
#define HAVE_BUS_H

#include "memory.h"


void bus_init (Memory *bus[]);
void bus_attach_device (Memory *bus[], Memory *mem);

Byte bus_read (Memory *bus[], int addr);
void bus_store (Memory *bus[], int addr, Byte b);

Word bus_read_word (Memory *bus[], int addr);
Word bus_read_word_zero (Memory *bus[], int addr);


#endif

